###################################################
##      Clocks
###################################################

# 125 MHz clock from onboard synthesizer

# IC33-OUT9


# 100 MHz PCIe clock



###################################################
##       PCIe
###################################################

set_property PACKAGE_PIN B10 [get_ports MMC_nreset_i]
set_property IOSTANDARD LVCMOS33 [get_ports MMC_nreset_i]
set_property PULLUP true [get_ports MMC_nreset_i]

set_property PACKAGE_PIN D14 [get_ports uart_txd_o]
set_property IOSTANDARD LVCMOS33 [get_ports uart_txd_o]
set_property PACKAGE_PIN C13 [get_ports uart_rxd_i]
set_property IOSTANDARD LVCMOS33 [get_ports uart_rxd_i]

#
##set_property PACKAGE_PIN AM2 [get_ports {pci_exp_rxp_i[0]}]
##set_property PACKAGE_PIN AM1 [get_ports {pci_exp_rxn_i[0]}]
##set_property PACKAGE_PIN AM6 [get_ports {pci_exp_txp_o[0]}]
##set_property PACKAGE_PIN AM5 [get_ports {pci_exp_txn_o[0]}]
##set_property PACKAGE_PIN AL4 [get_ports {pci_exp_rxp_i[1]}]
##set_property PACKAGE_PIN AL3 [get_ports {pci_exp_rxn_i[1]}]
##set_property PACKAGE_PIN AL8 [get_ports {pci_exp_txp_o[1]}]
##set_property PACKAGE_PIN AL7 [get_ports {pci_exp_txn_o[1]}]
##set_property PACKAGE_PIN AK2 [get_ports {pci_exp_rxp_i[2]}]
##set_property PACKAGE_PIN AK1 [get_ports {pci_exp_rxn_i[2]}]
##set_property PACKAGE_PIN AK6 [get_ports {pci_exp_txp_o[2]}]
##set_property PACKAGE_PIN AK5 [get_ports {pci_exp_txn_o[2]}]
##set_property PACKAGE_PIN AJ4 [get_ports {pci_exp_rxp_i[3]}]
##set_property PACKAGE_PIN AJ3 [get_ports {pci_exp_rxn_i[3]}]
##set_property PACKAGE_PIN AJ8 [get_ports {pci_exp_txp_o[3]}]
##set_property PACKAGE_PIN AJ7 [get_ports {pci_exp_txn_o[3]}]
#
## Commands for enabled transceiver GTHE4_CHANNEL_X0Y0
## ----------------------------------------------------------------------------------------------------------------------
#
## Channel primitive location constraint
#set_property LOC GTHE4_CHANNEL_X0Y0 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[0].*gen_gthe4_channel_inst[0].GTHE4_CHANNEL_PRIM_INST}]
#set_property LOC GTHE4_CHANNEL_X0Y3 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[0].*gen_gthe4_channel_inst[0].GTHE4_CHANNEL_PRIM_INST}]
#
## Channel primitive serial data pin location constraints
## (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
##set_property package_pin AM1 [get_ports gthrxn_in[0]]
##set_property package_pin AM2 [get_ports gthrxp_in[0]]
##set_property package_pin AM5 [get_ports gthtxn_out[0]]
##set_property package_pin AM6 [get_ports gthtxp_out[0]]
#
## CPLL calibration block constraints
#create_clock -period 8.000 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet
#
#
#
## Commands for enabled transceiver GTHE4_CHANNEL_X0Y1
## ----------------------------------------------------------------------------------------------------------------------
#
## Channel primitive location constraint
#set_property LOC GTHE4_CHANNEL_X0Y1 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[0].*gen_gthe4_channel_inst[1].GTHE4_CHANNEL_PRIM_INST}]
#set_property LOC GTHE4_CHANNEL_X0Y2 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[0].*gen_gthe4_channel_inst[1].GTHE4_CHANNEL_PRIM_INST}]
#
## Channel primitive serial data pin location constraints
## (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
##set_property package_pin AL3 [get_ports gthrxn_in[1]]
##set_property package_pin AL4 [get_ports gthrxp_in[1]]
##set_property package_pin AL7 [get_ports gthtxn_out[1]]
##set_property package_pin AL8 [get_ports gthtxp_out[1]]
#
## CPLL calibration block constraints
#create_clock -period 8.000 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet
#
#
#
## Commands for enabled transceiver GTHE4_CHANNEL_X0Y2
## ----------------------------------------------------------------------------------------------------------------------
#
## Channel primitive location constraint
#set_property LOC GTHE4_CHANNEL_X0Y2 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[0].*gen_gthe4_channel_inst[2].GTHE4_CHANNEL_PRIM_INST}]
#set_property LOC GTHE4_CHANNEL_X0Y1 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[0].*gen_gthe4_channel_inst[2].GTHE4_CHANNEL_PRIM_INST}]
#
## Channel primitive serial data pin location constraints
## (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
##set_property package_pin AK1 [get_ports gthrxn_in[2]]
##set_property package_pin AK2 [get_ports gthrxp_in[2]]
##set_property package_pin AK5 [get_ports gthtxn_out[2]]
##set_property package_pin AK6 [get_ports gthtxp_out[2]]
#
## CPLL calibration block constraints
#create_clock -period 8.000 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet
#
## Commands for enabled transceiver GTHE4_CHANNEL_X0Y3
## ----------------------------------------------------------------------------------------------------------------------
#
## Channel primitive location constraint
#set_property LOC GTHE4_CHANNEL_X0Y3 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[0].*gen_gthe4_channel_inst[3].GTHE4_CHANNEL_PRIM_INST}]
#set_property LOC GTHE4_CHANNEL_X0Y0 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[0].*gen_gthe4_channel_inst[3].GTHE4_CHANNEL_PRIM_INST}]
#
## Channel primitive serial data pin location constraints
## (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
##set_property package_pin AJ3 [get_ports gthrxn_in[3]]
##set_property package_pin AJ4 [get_ports gthrxp_in[3]]
##set_property package_pin AJ7 [get_ports gthtxn_out[3]]
##set_property package_pin AJ8 [get_ports gthtxp_out[3]]
#
## CPLL calibration block constraints
#create_clock -period 8.000 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet
#
## False path constraints
## ----------------------------------------------------------------------------------------------------------------------
#
#set_false_path -to [get_cells -hierarchical -filter {NAME =~ *bit_synchronizer*inst/i_in_meta_reg}]
#
###set_false_path -to [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_*_reg}]
#set_false_path -to [get_pins -filter REF_PIN_NAME=~*D -of_objects [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_meta*}]]
#set_false_path -to [get_pins -filter REF_PIN_NAME=~*PRE -of_objects [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_meta*}]]
#set_false_path -to [get_pins -filter REF_PIN_NAME=~*PRE -of_objects [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_sync1*}]]
#set_false_path -to [get_pins -filter REF_PIN_NAME=~*PRE -of_objects [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_sync2*}]]
#set_false_path -to [get_pins -filter REF_PIN_NAME=~*PRE -of_objects [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_sync3*}]]
#set_false_path -to [get_pins -filter REF_PIN_NAME=~*PRE -of_objects [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_out*}]]

###################################################
##      Clocks for MGTs SI5338 (U571) control
###################################################

## Bank 48 voltage = 1.8V
#set_property PACKAGE_PIN AF27 [get_ports mgt_ck_int_i]
#set_property IOSTANDARD LVCMOS18 [get_ports mgt_ck_int_i]
#
## Bank 48 voltage = 1.8v
#set_property PACKAGE_PIN AE27 [get_ports mgt_ck_scl_b]
#set_property IOSTANDARD LVCMOS18 [get_ports mgt_ck_scl_b]
#
## Bank 48 voltage = 1.8v
#set_property PACKAGE_PIN AG34 [get_ports mgt_ck_sda_b]
#set_property IOSTANDARD LVCMOS18 [get_ports mgt_ck_sda_b]
#
#
####################################################
###      SFP optical links
####################################################
#
#set_property PACKAGE_PIN L8 [get_ports rtm_usr_sda_b]
#set_property IOSTANDARD LVCMOS18 [get_ports rtm_usr_sda_b]
#
#set_property PACKAGE_PIN K8 [get_ports rtm_usr_scl_b]
#set_property IOSTANDARD LVCMOS18 [get_ports rtm_usr_scl_b]
#
### Optical links (white rabbit)
#

set_property PACKAGE_PIN AE11 [get_ports mgtclk1_224_n_i]
set_property PACKAGE_PIN AE12 [get_ports mgtclk1_224_p_i]

#

### I2C  (FPGA_I2C)
#
set_property PACKAGE_PIN A11 [get_ports i2c_scl_b]
set_property IOSTANDARD LVCMOS33 [get_ports i2c_scl_b]
#
set_property PACKAGE_PIN A12 [get_ports i2c_sda_b]
set_property IOSTANDARD LVCMOS33 [get_ports i2c_sda_b]
#
#set_property PACKAGE_PIN AK33 [get_ports sfp1_prsnt_n_i]
#set_property IOSTANDARD LVCMOS12 [get_ports sfp1_prsnt_n_i]
#set_property PULLUP true [get_ports sfp1_prsnt_n_i]
#
### Link 1
#
set_property PACKAGE_PIN M2 [get_ports {mgt228_rx_p_i[0]}]
set_property PACKAGE_PIN M1 [get_ports {mgt228_rx_n_i[0]}]
set_property PACKAGE_PIN M6 [get_ports {mgt228_tx_p_o[0]}]
set_property PACKAGE_PIN M5 [get_ports {mgt228_tx_n_o[0]}]

set_property PACKAGE_PIN L4 [get_ports {mgt228_rx_p_i[1]}]
set_property PACKAGE_PIN L3 [get_ports {mgt228_rx_n_i[1]}]
set_property PACKAGE_PIN L8 [get_ports {mgt228_tx_p_o[1]}]
set_property PACKAGE_PIN L7 [get_ports {mgt228_tx_n_o[1]}]

set_property PACKAGE_PIN K2 [get_ports {mgt228_rx_p_i[2]}]
set_property PACKAGE_PIN K1 [get_ports {mgt228_rx_n_i[2]}]
set_property PACKAGE_PIN K6 [get_ports {mgt228_tx_p_o[2]}]
set_property PACKAGE_PIN K5 [get_ports {mgt228_tx_n_o[2]}]

set_property PACKAGE_PIN J4 [get_ports {mgt228_rx_p_i[3]}]
set_property PACKAGE_PIN J3 [get_ports {mgt228_rx_n_i[3]}]
set_property PACKAGE_PIN J8 [get_ports {mgt228_tx_p_o[3]}]
set_property PACKAGE_PIN J7 [get_ports {mgt228_tx_n_o[3]}]
#
### Link 2
#
set_property PACKAGE_PIN T2 [get_ports {mgt227_rx_p_i[0]}]
set_property PACKAGE_PIN T1 [get_ports {mgt227_rx_n_i[0]}]
set_property PACKAGE_PIN T6 [get_ports {mgt227_tx_p_o[0]}]
set_property PACKAGE_PIN T5 [get_ports {mgt227_tx_n_o[0]}]

set_property PACKAGE_PIN R4 [get_ports {mgt227_rx_p_i[1]}]
set_property PACKAGE_PIN R3 [get_ports {mgt227_rx_n_i[1]}]
set_property PACKAGE_PIN R8 [get_ports {mgt227_tx_p_o[1]}]
set_property PACKAGE_PIN R7 [get_ports {mgt227_tx_n_o[1]}]

set_property PACKAGE_PIN P2 [get_ports {mgt227_rx_p_i[2]}]
set_property PACKAGE_PIN P1 [get_ports {mgt227_rx_n_i[2]}]
set_property PACKAGE_PIN P6 [get_ports {mgt227_tx_p_o[2]}]
set_property PACKAGE_PIN P5 [get_ports {mgt227_tx_n_o[2]}]

set_property PACKAGE_PIN N4 [get_ports {mgt227_rx_p_i[3]}]
set_property PACKAGE_PIN N3 [get_ports {mgt227_rx_n_i[3]}]
set_property PACKAGE_PIN N8 [get_ports {mgt227_tx_p_o[3]}]
set_property PACKAGE_PIN N7 [get_ports {mgt227_tx_n_o[3]}]


###################################################
##  MMC signals
###################################################

## Bank 65 voltage = 2.5V (MISO)
#set_property PACKAGE_PIN K22 [get_ports mmc_zone3_a1_flag_i]
#set_property IOSTANDARD LVCMOS25 [get_ports mmc_zone3_a1_flag_i]
#
## Bank 65 voltage = 2.5V (MOSI)
#set_property PACKAGE_PIN N27 [get_ports mmc_zone3_a0_flag_i]
#set_property IOSTANDARD LVCMOS25 [get_ports mmc_zone3_a0_flag_i]

# MISO will be used as MMC_ZONE3_A1 flag

# Bank 65 voltage = 2.5V
#set_property PACKAGE_PIN K22 [get_ports mmc_spi_miso];
#set_property IOSTANDARD LVCMOS25 [get_ports mmc_spi_miso];# Bank 65 voltage = 2.5V

# MOSI will be used as MMC_ZONE3_a0 flag

# Bank 65 voltage = 2.5v
#set_property PACKAGE_PIN N27 [get_ports mmc_spi_mosi];
#set_property IOSTANDARD LVCMOS25 [get_ports mmc_spi_mosi];# Bank 65 voltage = 2.5V

# Bank 64 voltage = 2.5v
#set_property PACKAGE_PIN AE10 [get_ports mmc_spi_sck];
#set_property IOSTANDARD LVCMOS25 [get_ports mmc_spi_sck]; # Bank 64 voltage = 2.5V

# Bank 65 voltage = 2.5v
#set_property PACKAGE_PIN H23 [get_ports mmc_spi_ss_l];
#set_property IOSTANDARD LVCMOS25 [get_ports mmc_spi_ss_l];# Bank 65 voltage = 2.5V

## Bank 34 voltage = 1.2v
#set_property PACKAGE_PIN AP18 [get_ports mmc_fpga_rxd_i]
#set_property IOSTANDARD LVCMOS12 [get_ports mmc_fpga_rxd_i]
#
## Bank 34 voltage = 1.2v
#set_property PACKAGE_PIN AP16 [get_ports mmc_fpga_txd_i]
#set_property IOSTANDARD LVCMOS12 [get_ports mmc_fpga_txd_i]








###################################################
##  White Rabbit
###################################################

# Bank 64 voltage = 2.5V
#set_property PACKAGE_PIN AG10 [get_ports WR_CLK_N]
#set_property IOSTANDARD LVDS_25 [get_ports WR_CLK_N]
#set_property DIFF_TERM_ADV TERM_100 [get_ports WR_CLK_N]

## Bank 64 voltage = 2.5V
#set_property PACKAGE_PIN AF10 [get_ports WR_CLK_P]
#set_property IOSTANDARD LVDS_25 [get_ports WR_CLK_P]
#set_property DIFF_TERM_ADV TERM_100 [get_ports WR_CLK_P]

## Bank 64 voltage = 1.8V
set_property PACKAGE_PIN AT6 [get_ports clk_20m_vcxo1_i]
set_property IOSTANDARD LVCMOS18 [get_ports clk_20m_vcxo1_i]


# WR DAC 1 Bank voltage = 3.3V
set_property PACKAGE_PIN G10 [get_ports wr_dac1_din_o]
set_property IOSTANDARD LVCMOS33 [get_ports wr_dac1_din_o]

set_property PACKAGE_PIN G11 [get_ports wr_dac1_sclk_o]
set_property IOSTANDARD LVCMOS33 [get_ports wr_dac1_sclk_o]

set_property PACKAGE_PIN H12 [get_ports {wr_dac1_sync_n_o[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {wr_dac1_sync_n_o[0]}]

set_property PACKAGE_PIN H11 [get_ports {wr_dac1_sync_n_o[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {wr_dac1_sync_n_o[1]}]

set_property PACKAGE_PIN J10 [get_ports si57x_scl_b]
set_property IOSTANDARD LVCMOS33 [get_ports si57x_scl_b]

set_property PACKAGE_PIN J11 [get_ports si57x_sda_b]
set_property IOSTANDARD LVCMOS33 [get_ports si57x_sda_b]


# WR DAC 2 Bank voltage = 3.3V





###################################################
##  MLVDS Bus (Buffer - single ended - FPGA)
###################################################

# Bank voltage = 3.3V
# TX17

# TX18

# TX19

# TX20

# RX17

# RX18

# RX19

# RX20

# TX drive 17

# TX drive 18

# TX drive 19

# TX drive 20

# RX drive 17

# RX drive 18

# RX drive 19

# RX drive 20

###################################################
##  FMC 1
###################################################


###################################################
##  FMC2
###################################################



###################################################
##  diverse
###################################################

## LED signals


#set_property IOSTANDARD DIFF_SSTL12 [get_ports clk_ddr_clk_p]
#set_property IOSTANDARD DIFF_SSTL12 [get_ports clk_ddr_clk_n]

## Others

# Acknowledge DRC that rtm_usr_sda_b port will be unavailable during calibration via IODelay Controller as it shares same bank
#set_property UNAVAILABLE_DURING_CALIBRATION TRUE [get_ports rtm_usr_sda_b]




